Attribute VB_Name = "Module1"
' --> Creates a picture object from an image handle <----
'This is a derivation of the code found in MS KB article ID
'Q141933 (or Q161299) "HOWTO: VB4: Capture and Print the
'Screen, a Form, or any Window"



Type GUID
  Data1 As Long
  Data2 As Integer
  Data3 As Integer
  Data4(7) As Byte
End Type


Type PICTDESC
   cbSize As Long
   picType As Long   ' one of VB's PictureTypeConstants
   hImage As Long    ' HBITMAP, HMETAFILE, HICON, HENHMETAFILE
   Data1 As Long      ' HBITMAP hpal, HMETAFILE xExt
   Data2 As Long      ' HMETAFILE yExt
End Type


' Note that IPicture is a hidden interface implemented by the
' OLE Automation type library Stdole2.tlb. You will need to add
' a project reference to the typelib in order to use this function.
Declare Function OleCreatePictureIndirect Lib "olepro32.dll" _
                            (pPictDesc As PICTDESC, _
                            RefIID As GUID, _
                            ByVal fPictureOwnsHandle As Long, _
                            ppvObj As IPicture) As Long


Public Const S_OK = 0   ' indicates successful HRESULT


'====================================================================
' Creates a picture object from an image handle
'   hImage      - either a HBITMAP, HMETAFILE, HICON or HENHMETAFILE
'   dwPicType - one of VB's PictureTypeConstants describing the hImage param.


' Returns a VB Picture object on success, or the object value "Nothing" on error.


Public Function GetPicture(hImage As Long, _
                                        dwPicType As PictureTypeConstants) As Picture
  Dim pd As PICTDESC
  Dim IID_IDispatch As GUID
  Dim objPic As Picture


  If hImage = 0 Then Exit Function


  ' Fill the picture description struct
  With pd
    .cbSize = Len(pd)         ' must specify the struct's size
    .picType = dwPicType   ' vbPicTypeIcon
    .hImage = hImage
  End With


  ' Fill the IDispatch Interface ID, {00020400-0000-0000-C000-000000046}
  With IID_IDispatch
    .Data1 = &H20400
    .Data4(0) = &HC0
    .Data4(7) = &H46
  End With


  ' Create the Picture object from the image handle
  If OleCreatePictureIndirect(pd, IID_IDispatch, True, objPic) = S_OK Then
    Set GetPicture = objPic
  End If


End Function


'====================================================================
'====================================================================
'====================================================================
